#pragma once

#undef GetEnvironmentVariable
#undef GetCurrentDirectory

using namespace System;
using namespace System::IO;					// for StreamWriter I/O to a file
using namespace System::Text;				// for Encoding::ASCII
using namespace System::Windows::Forms;		// for RichTextBox ...
using namespace System::Reflection;			// for Assembly::GetExecutingAssembly()

namespace MyNamespace
{
	/// <summary>
	///		Global services for several of Harry's programs
	///		Developed in TURBO Pascal 5.5 and 6.0, converted to Visual Basic 6,
	///		Visual C# .Net and now in Visual C++ .Net
	///
	/// ---------------- *** LEGAL NOTICE: *** ------------------
	///
	/// This program is free software; you can redistribute it and/or modify
	/// it under the terms of the GNU General Public License (GPL) as published
	/// by the Free Software Foundation. cf. the file COPYING.txt.
	///
	/// ------------ *** end of legal notice *** ------------------
	/// </summary>

	public ref class Global :  public System::ComponentModel::Component
	{
		public: Global(void)	// constructor logic
		{
			InitializeComponent();

			command = "";
			helpUp = 0;
			myURL = "hjsmithh@sbcglobal.net  http://www.geocities.com/hjsmithh/";
			programURL = "http://www.geocities.com/hjsmithh/download.html";
			runFormUp = false;
			newHelp = false;
			newSetLogCaption = false;
			GetAssemblyAttributes();
			nL = Environment::NewLine;
			nL2 = nL + nL;
			nLc = nL;						// line continuation mark for WriteT nL or "-" + nL
			logg = false;
			logFile = "";
			muErrRep = true;
		}

		Global(System::ComponentModel::IContainer ^container)
		{
			/// <summary>
			/// Required for Windows.Forms Class Composition Designer support
			/// </summary>

			container->Add(this);
			InitializeComponent();
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected: ~Global()
		{
			if (components)
			{
				delete components;
			}
		}

		/// <summary>
		/// Required designer variable.
		/// </summary>
		private: System::ComponentModel::Container ^components;

#pragma region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		void InitializeComponent(void)
		{
			components = gcnew System::ComponentModel::Container();
		}
#pragma endregion

		public: static bool IsInt32(String^ sInt32) // is input string a good 32-bit signed integer?
		{
			int iInt32;
			return Int32::TryParse(sInt32, iInt32);
		}

		public: static void Write(String^ message) // write a short message to outS
		{
			Write(outS, nullF, message);
		}

		public: static void WriteLn() // write a linefeed to outS
		{
			WriteLn(outS, nullF, "");
		}

		public: static void WriteLn(String^ message) // write a short message and a linefeed to outS
		{
			WriteLn(outS, nullF, message);
		}

		public: static void WriteLn(RichTextBox^ outB, StreamWriter^ outF) // Write linefeed
		{
			Write(outB, outF, nL);
		}

		public: static void WriteLn(RichTextBox^ outB, StreamWriter^ outF, String^ st) // Write st plus linefeed
		{
			Write(outB, outF, st + nL);
		}

		public: static void WriteLn2() // Write 2 linefeeds to outS
		{
			Write(outS, nullF, nL2);
		}

		public: static void WriteLn2(String^ st) // Write st plus 2 linefeeds to outS
		{
			Write(outS, nullF, st + nL2);
		}

		public: static void WriteLn2(RichTextBox^ outB, StreamWriter^ outF) // Write 2 linefeeds
		{
			Write(outB, outF, nL2);
		}

		public: static void WriteLn2(RichTextBox^ outB, StreamWriter^ outF, String^ st) // Write st plus 2 linefeeds
		{
			Write(outB, outF, st + nL2);
		}

		public: static void WriteSLn(String^ st) // Write SingleSpace, st, and linefeed to outS
		{
			SingleSpace(outS);
			Write(outS, nullF, st + nL);
		}

		public: static void WriteDLn(String^ st) // Write DoubleSpace, st, and linefeed to outS
		{
			DoubleSpace(outS);
			Write(outS, nullF, st + nL);
		}

		public: static void WriteDLn2(String^ st) // Write DoubleSpace, st, and 2 linefeeds to outS
		{
			DoubleSpace(outS);
			Write(outS, nullF, st + nL2);
		}

		public: static void WriteDLn(RichTextBox^ outB, StreamWriter^ outF, String^ st) // Write DoubleSpace, st, and linefeed
		{
			DoubleSpace(outB);
			Write(outB, outF, st + nL);
		}

		public: static void Write(RichTextBox^ outB, StreamWriter^ outF, String^ st) // print String^ to RichTextBox or to a file
		{
			if (st == "") return;
			if (outF != nullF)
			{
				try { outF->Write(st); }
				catch (const char ex) { ReportError("Write", ex.ToString()); }
			}
			if (outB != nullB)
			{
				outB->AppendText(st);
				if (st[(st->Length - 1)] == '\n')	// if a new line, move to bottom/end of output text box
				{
					runTextOut->Select(runTextOut->Text->Length, 0);
					runTextOut->Focus();
				}
				if (logg && (outB == outS))			// only log output to Run form textbox
				{
					try { outL->Write(st); }
					catch (const char) { }
				}
				if (outB->Text->Length > 200000)		// clear top of screen after about 50 full pages
				{
					int i = outB->Text->IndexOf("\n", 4000);
					outB->Text = outB->Text->Substring(i + 1);	// delete partial line
				}
			}
		} // Write

		public: static void WriteT(String^ st)
		// WriteT with 0 tot and 0 width to outS
		{
			int tot = 0;
			SingleSpace();
			WriteT(outS, nullF, st, tot, 0);
		}

		public: static void WriteT(String^ st, int tot)
		// WriteT with 0 width to outS
		{
			WriteT(outS, nullF, st, tot, 0);
		}

		public: static void WriteT(RichTextBox^ outB, StreamWriter^ outF, String^ st)
		// WriteT with 0 tot and 0 width
		{
			int tot = 0;
			SingleSpace(outB);
			WriteT(outB, outF, st, tot, 0);
		}

		public: static void WriteT(RichTextBox^ outB, StreamWriter^ outF, String^ st, int tot)
		// WriteT with 0 width
		{
			WriteT(outB, outF, st, tot, 0);
		}

		public: static void WriteTLn()
		// WriteTLn with "", 0 tot and 0 width to outS
		{
			Write(outS, nullF, nL);
		}

		public: static void WriteTLn(String^ st)
		// WriteTLn with 0 tot and 0 width to outS
		{
			int tot = 0;
			SingleSpace();
			if (st != "") WriteT(outS, nullF, st, tot, 0);
			Write(outS, nullF, nL);
		}

		public: static void WriteTLn(String^ st, int tot)
		// WriteT and linefeed to outS
		{
			if (st != "") WriteT(outS, nullF, st, tot, 0);
			Write(outS, nullF, nL);
			tot = 0;
		}

		public: static void WriteTLn(RichTextBox^ outB, StreamWriter^ outF, String^ st)
		// WriteT and linefeed with 0 tot and 0 width
		{
			int tot = 0;
			SingleSpace(outB);
			if (st != "") WriteT(outB, outF, st, tot, 0);
			Write(outB, outF, nL);
		}

		public: static void WriteTLn(RichTextBox^ outB, StreamWriter^ outF, String^ st, int tot)
		// WriteT and linefeed with 0 width
		{
			if (st != "") WriteT(outB, outF, st, tot, 0);
			Write(outB, outF, nL);
			tot = 0;
		}

		public: static void WriteTLn(RichTextBox^ outB, StreamWriter^ outF, String^ st, int tot, int width)
		// WriteT and linefeed
		{
			if (st != "") WriteT(outB, outF, st, tot, width);
			Write(outB, outF, nL);
			tot = 0;
		}

		public: static void WriteTLn2(String^ st)
		// WriteTLn2 with 0 tot and 0 width to outS
		{
			int tot = 0;
			SingleSpace();
			if (st != "") WriteT(outS, nullF, st, tot, 0);
			Write(outS, nullF, nL2);
		}

		public: static void WriteTLn2(RichTextBox^ outB, StreamWriter^ outF, String^ st)
		// WriteTLn2 with 0 tot and 0 width
		{
			int tot = 0;
			SingleSpace(outB);
			if (st != "") WriteT(outB, outF, st, tot, 0);
			Write(outB, outF, nL2);
		}

		public: static void WriteTLn2(RichTextBox^ outB, StreamWriter^ outF, String^ st, int tot, int width)
		// WriteT and a double linefeed after
		{
			if (st != "") WriteT(outB, outF, st, tot, width);
			Write(outB, outF, nL2);
			tot = 0;
		}

		public: static void WriteTD(RichTextBox^ outB, StreamWriter^ outF, String^ st)
		// force double space and WriteT with 0 tot and 0 width
		{
			int tot = 0;
			SingleSpace(outB);
			WriteT(outB, outF, st, tot, 0);
		}

		public: static void WriteTDLn(String^ st)
		// WriteT with a guaranteed double linefeed before and single linefeed after to outS
		{
			DoubleSpace(outS);
			WriteTLn(outS, nullF, st);
		}

		public: static void WriteTDLn(RichTextBox^ outB, StreamWriter^ outF, String^ st)
		// WriteT with a guaranteed double linefeed before and single linefeed after
		{
			DoubleSpace(outB);
			WriteTLn(outB, outF, st);
		}

		public: static void WriteT(RichTextBox^ outB, StreamWriter^ outF, String^ st, int tot, int width)
		// output String and linefeed every 60, 80 or width characters
		// tot = characters on line so far
		{
			int i;
			int j;
			int iL;
			int n;
			String^ stE;
			if (width > 0)
				n = width;
			else
			{
				if (!outB) n = 60;	// 80 for screen, 60 for files
				else n = 80;
			}
			i = 1;
			j = n - tot;
			iL = st->Length;
			while (iL > 0)
			{
				stE = "";
				if (tot >= n)
				{
					stE = nLc;				// format n characters per line
					j = n;
					tot = 0;
				}
				if (iL <= j)
				{
					Write(outB, outF, stE + st->Substring(i - 1));	// built for speed
					tot += iL;									// don't call Write too often
					iL = 0;
				}
				else
				{
					Write(outB, outF, stE + st->Substring(i - 1, j));
					i += j;
					iL -= j;
					j = n;
					tot = n;
				}
			}
		} // WriteT

		public: static void MuWriteErr(String^ st)	// write error statement to outS and set error flag
		{
			muErr = true;
			if (muErrRep) WriteDLn(st);
		}

		public: static void Write(float x)			// Write x to TextOut
		{
			runTextOut->Text += x.ToString();
		}

		public: static void SingleSpace()	// guarantee a single line space in outS
		{
			SingleSpace(outS);
		}

		public: static void SingleSpace(RichTextBox^ outB)	// guarantee a single line space in output box
		{
			int iL = outB->Text->Length;
			if (iL > 0)
			{
				if (outB->Text->Substring(iL - 1) != "\n") WriteLn(outB, nullF);
			}
		}

		public: static void DoubleSpace(RichTextBox^ outB) // guarantee a double line space in output box
		{
			int iL = outB->Text->Length;
			if (iL > 0)
			{
				if (outB->Text->Substring(iL - 1) != "\n") WriteLn(outB, nullF);
				if (outB->Text->Substring(outB->Text->Length - 2) != "\n\n") WriteLn(outB, nullF);
			}
		}

		public: static void DoubleSpace() // guarantee a double line space in outS
		{
			DoubleSpace(outS);
		}

		public: static void GetAssemblyAttributes() // and version
		{
			system = Environment::GetEnvironmentVariable("SYSTEM");
			if (system->IsNullOrEmpty(system))
				system = "";
			else
				system += Environment::NewLine;
			system += Environment::GetEnvironmentVariable("COMPUTERNAME");
			system += " by ";
			system += Environment::GetEnvironmentVariable("USERNAME");
			if (system->IsNullOrEmpty(system) || system == "")
				system = "<Computer system name not set>";
			Attribute^ attr;
			for each (attr in Assembly::GetExecutingAssembly()->GetCustomAttributes(false))
			{
				if ( attr->GetType() == AssemblyTitleAttribute::typeid )
					title = (dynamic_cast<AssemblyTitleAttribute^>(attr))->Title;

				if ( attr->GetType() == AssemblyDescriptionAttribute::typeid )
					description = (dynamic_cast<AssemblyDescriptionAttribute^>(attr))->Description;

				if ( attr->GetType() == AssemblyConfigurationAttribute::typeid )
					configuration = (dynamic_cast<AssemblyConfigurationAttribute^>(attr))->Configuration;

				if ( attr->GetType() == AssemblyCompanyAttribute::typeid )
					company = (dynamic_cast<AssemblyCompanyAttribute^>(attr))->Company;

				if ( attr->GetType() == AssemblyProductAttribute::typeid )
					product = (dynamic_cast<AssemblyProductAttribute^>(attr))->Product;

				if ( attr->GetType() == AssemblyCopyrightAttribute::typeid )
					copyright = (dynamic_cast<AssemblyCopyrightAttribute^>(attr))->Copyright;

				if ( attr->GetType() == AssemblyTrademarkAttribute::typeid )
					trademark = (dynamic_cast<AssemblyTrademarkAttribute^>(attr))->Trademark;
			}
			Version aVersion = Assembly::GetExecutingAssembly()->GetName()->Version->ToString();
			int versionMajor = aVersion.Major;
			int versionMinor = aVersion.Minor;
			int versionBuild = aVersion.Build;				// the number of days since January 1, 2000 local time
			int versionRevision = aVersion.Revision;		// the number of seconds since midnight local time, divided by 2
			version = "C++ Forms Version " + aVersion.ToString();
			name1   = product;
			name2   = description;
			author  = copyright;
			address = trademark;
			array<String^>^ fields;
			fields = title->Split(L' ');	// convert the string to an array each, number is separated by a space
			pName  = fields[0]->ToString();
		} // GetAssemblyAttributes

		public: static bool OpenRead(StreamReader^& inF, String^ fName, String^ dir)
		// open file for Reading from CurrentDirectory or homeDir
		{
			String^ stEx1;
			String^ stEx2 = "";
			String^ savDir = Environment::CurrentDirectory->ToString();
			if (!quiet) DoubleSpace();
			dir = savDir;
			if (OpenReadFile(inF, fName, stEx1))
			{
				if (!quiet)
				{
					WriteDLn("File " + fName + " opened for reading");
					WCurDir(fName);
				}
				return true;
			}
			if (savDir != homeDir)
			{
				dir = homeDir;
				Directory::SetCurrentDirectory(homeDir);
				if (OpenReadFile(inF, fName, stEx2))
				{
					if (!quiet)
					{
						WriteLn("File " + fName + " opened for reading");
						WCurDir(fName);
					}
					Directory::SetCurrentDirectory(savDir);
					return true;
				}
				Directory::SetCurrentDirectory(savDir);
			}
			dir = "";
			WriteLn("Cannot open file " + fName + " for input");
			WriteTLn("Not in current directory " + savDir);
			ReportError("OpenRead", stEx1);			// file not found most likely
			if (savDir != homeDir)
			{
				WriteTLn("Not in home directory " + homeDir);
				ReportError("OpenRead", stEx2);	// file not found most likely
			}
			return false;
		} // OpenRead

		public: static bool OpenReadFile(StreamReader^& inF, String^ fName, String^ stEx)
		// open file for Reading from CurrentDirectory
		{
			stEx = "";
			try
			{
				inF = gcnew StreamReader(fName); // open fName for input as inF
				return true;
			}
			catch (FileNotFoundException^ ex)
			{
				stEx = ex->ToString();
				return false;
			}
			catch (const char ex)
			{
				stEx = ex.ToString();
				return false;
			}
		} // OpenReadFile

		public: static void ReportError(String^ who, String^ errorMessage) // report IOResult etc. error, errorMessage = caught.Message
		{
			GC::Collect(); // force garbage collection of all generations
			muErr = true;
			if (errorMessage == "") return;
			if (muErrRep) WriteTLn(who + ": " + errorMessage);
		}

		public: static void WCurDir(String^ fName)
		// write current disk directory with final \
		// using Environment.CurrentDirectory.ToString(): C:\ already has the \ but non-root directories do not
		{
			// this can garble some output, but good info
			String^ cD = Directory::GetCurrentDirectory();
			if (cD->Substring(cD->Length - 1) != "\\") cD += "\\";
			if (fName->Length > 1 && fName[1] == ':')
			{
				WriteTLn("Directory name = " + cD);
			}
			else
			{
				WriteTLn("Full name = " + cD + fName);
			}
		}

		public: static void ClearLog()	// clear Log file
		{
			DateTimePicker^ dateTime = gcnew System::Windows::Forms::DateTimePicker();
			String^ dateTimeString = dateTime->Value.ToString();
			bool logS = logg;	// save Log status in a local
			if (!quiet) DoubleSpace();
			if (logg)
			{
				String^ st = "Log file " + logFile + " Closed " + dateTimeString;
				if (!quiet)
				{
					WriteLn(st);
					outL->WriteLine();
				}
				WriteLn(nullB, outL);
				outL->Close();		// close the file
				logg = false;
			}
			logFile = "";
			logFile = CalLFile(logFile);	// get log file name, it may have changed
			// open logFile for output as outL, clear the file, outL gotten by open routine
			if (ChkWrite(outL, logFile, ""))
			{
				logg = true;		// set to get message to the file
				String^ st = "Log file " + logFile + " Cleared " + dateTimeString;
				if (!quiet)
				{
					WriteLn(st);
					WCurDir(logFile);
				}
				else
				{
					outL->WriteLine(st);
				}
				outL->WriteLine(Global::title + ", " + Global::version);
				if (Global::system != "") outL->WriteLine("Run on: " + Global::system);
				if (!quiet)
				{
					WriteLn();
				}
				else
				{
					outL->WriteLine();
				}
				if (!logS)
				{
					outL->Close();		// close the file
					logg = false;
					logFile = "";		// clear name when it is closed, not if its open
				}
			}
		} // ClearLog

		public: static void ToggleLogg() //Toggle Logging of output screen to Log File
		{
			DateTimePicker^ dateTime = gcnew DateTimePicker();
			String^ dateTimeString = dateTime->Value.ToString();
			if (!quiet) DoubleSpace();
			if (logg)
			{
				String^ st = "Log file " + logFile + " Closed " + dateTimeString;
				if (!quiet)
				{
					WriteLn(st);
					outL->WriteLine();
				}
				outL->Close();	// close the file
				logFile = "";			// allow for getting a new log file name next open
				logg = false;
			}
			else
			{
				logFile = CalLFile(logFile); // get log file name
				bool check;
				check = ChkAppend(outL, logFile);
				if (check) // open logFile for Append as outL
				{
					logg = true;
					String^ st = "Log file " + logFile + " Opened for Append " + dateTimeString;
					if (!quiet)
					{
						WriteDLn(st);
						WCurDir(logFile);
						outL->WriteLine(Global::title + ", " + Global::version);
						if (Global::system != "") outL->WriteLine("Run on: " + Global::system);
					}
				}
				else
				{
					logFile = ""; // file did not open
					return;
				}
			}
			newSetLogCaption = true; // call sub in Run form
		} // ToggleLogg

		public: static bool OpenWrite(StreamWriter^ outF, String^ fName) // open file for Writing
		{
			try
			{
				// open fName for output as outF
				outL = gcnew StreamWriter(fName, false, Encoding::ASCII); // Appending = false
				outF = outL;
				if (!quiet)
				{
					WriteDLn("File " + fName + " opened for writing");
					WCurDir(fName);
				}
				return true;
			}
			catch (const char ex)
			{
				WriteDLn("Cannot open file " + fName + " for output");
				WCurDir(fName);
				ReportError("OpenWrite", ex.ToString());
				return false;
			}
		} // OpenWrite

		public: static bool ChkWrite(StreamWriter^ outF, String^ fName, String^ st)
		// check start write of file
		{
			if (!OpenWrite(outF, fName))
			{
				if (MakeReady() == ::DialogResult::OK)
				{
					if (!OpenWrite(outF, fName))
					{
						WriteLn("Aborting file write...");
						return false;
					}
				}
			}
			if (!quiet) WriteTLn("Writing file " + fName + st);
			return true;
		}

		public: static bool OpenAppend(StreamWriter^ outF, String^ fName)	// open file for Writing
		{
			try
			{
				// open fName for Append as outF
				outF = gcnew StreamWriter(fName, true, Encoding::ASCII);		//Appending = true
				outL = outF;
				return true;
			}
			catch (const char ex)
			{
				WriteDLn("Cannot open file " + fName + " for output");
				WCurDir(fName);
				ReportError("OpenAppend", ex.ToString());
				return false;
			}
		}

		public: static bool ChkAppend(StreamWriter^ outF, String^ fName)
		// check start Append to a file
		{
			if (!OpenAppend(outF, fName))
			{
				if (MakeReady() == ::DialogResult::OK)
				{
					if (!OpenAppend(outF, fName))
					{
						WriteLn("Aborting file write...");
						return false;
					}
				}
			}
			return true;
		}

		public: static DialogResult MakeReady() // pause for operator to make file/drive ready
		{
			System::Windows::Forms::DialogResult key;
			key = MessageBox::Show(Global::pName + ": Make file/drive ready and click \"OK\"\n" +
								StringOf(29, " ") + "or \"Cancel\"",
				Global::title,
				MessageBoxButtons::OKCancel,
				MessageBoxIcon::Exclamation);
			// pause ----------
			if (key != ::DialogResult::OK) WriteLn("I/O operation aborted by operator!");
			return key;
		}

		public: static String^ StringOf(int n, String^ stIn) // repeat stIn, n times
		{
			String^ stOut = "";
			for (int i = 0; i < n; i++)
			{
				stOut += stIn;
			}
			return stOut;
		}

		public: static String^ CalLFile(String^ fName) // establish log file name
		{
			if (fName == "")
				fName = logFileB;
			return fName;
		}

		public: static String^ system;			// EnvironmentVariable("SYSTEM")
		public: static String^ title;			// this is an example of retrieving AssemblyInfo
		public: static String^ description;		// see GetAssemblyAttributes() above
		public: static String^ configuration;
		public: static String^ company;
		public: static String^ product;
		public: static String^ copyright;
		public: static String^ trademark;

		public: static String^ name1;			// = product
		public: static String^ name2;			// = description
		public: static String^ version;			// = "C++ Version x.x.xxxx.xxxxx"
		public: static String^ author;			// = copyright
		public: static String^ address;			// = trademark

		public: static bool logg;				// true if Logging screen output to FILE
		public: static bool muErr;				// true if error occurred
		public: static bool muErrRep;			// true if error reports are desired
		public: static bool parmsDone;			// true if command line parameters have been processed
		public: static bool quiet;				// true if "quiet" mode is on
		public: static bool runFormUp;			// the Run Form is up and running
		public: static bool tExitFlag;			// command to totally exit the program
		public: static bool tQuitReq;			// request to totally quit the program
		public: static int helpUp;				// number of Help form up and running
		public: static RichTextBox^ inS;		// input Screen source of commands
		public: static RichTextBox^ outS;		// screen Output destination
		public: static RichTextBox^ runTextIn;	// main input window on Run form
		public: static RichTextBox^ runTextOut;	// main output window on Run form
		public: static RichTextBox^ nullB;		// null RichTextBox
		public: static StreamWriter^ outL;		// log file output #
		public: static StreamWriter^ nullF;		// null file output #
		public: static String^ command;			// commands from command line arguments
		public: static String^ homeDir;			// initial disk directory when program started
		public: static String^ logFile;			// file name of log file or "" if not logging
		public: static String^ logFileB;		// base log file name
		public: static String^ myURL;			// my e-mail address and homepage URL
		public: static String^ nL;				// one Environment.NewLine \n or \r or \r\n
		public: static String^ nL2;				// nL + nL
		public: static String^ nLc;				// line continuation mark for WriteT nL or "-" + nL
		public: static String^ pName;			// from title
		public: static String^ programURL;		// URL of related web page

		public: static bool newHelp;			// true to bring up a new Help Form
		public: static bool newSetLogCaption;	// true to call RunForm::SetLogCaption()
	};
}
