#pragma once

using namespace System;

namespace MyNamespace
{
	/// <summary>
	///		HelpForm for several of Harry's programs
	///
	/// ---------------- *** LEGAL NOTICE: *** ------------------
	///
	/// This program is free software; you can redistribute it and/or modify
	/// it under the terms of the GNU General Public License (GPL) as published
	/// by the Free Software Foundation. cf. the file COPYING.txt.
	///
	/// ------------ *** end of legal notice *** ------------------
	/// </summary>

	public ref class HelpForm : public System::Windows::Forms::Form
	{
		public:
		HelpForm(void)
		{
			InitializeComponent();

			helpTextOut = richTextOut;
			helpTextOut->Clear();
			findSt = "";
		}

		protected:
		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		~HelpForm()
		{
			RunForm::helpWidth = this->Width;
			RunForm::helpHeight = this->Height;
			if (components)
			{
				delete components;
			}
		}
		private: System::Windows::Forms::MenuStrip^  menuStripHelp;
		private: System::Windows::Forms::Label^  labelTitle;
		private: System::Windows::Forms::ToolStripMenuItem^  fileToolStripMenuItem;
		private: System::Windows::Forms::ToolStripMenuItem^  exitToolStripMenuItem;
		private: System::Windows::Forms::RichTextBox^  richTextOut;
		private: System::Windows::Forms::Button^  buttonFind;
		private: System::Windows::Forms::Button^  buttonFindUp;
		private: System::Windows::Forms::TextBox^  textBoxFind;

	protected: 

		private:
		/// <summary>
		/// Required designer variable.
		/// </summary>
		System::ComponentModel::Container ^components;

#pragma region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		void InitializeComponent(void)
		{
			System::ComponentModel::ComponentResourceManager^  resources = (gcnew System::ComponentModel::ComponentResourceManager(HelpForm::typeid));
			this->menuStripHelp = (gcnew System::Windows::Forms::MenuStrip());
			this->fileToolStripMenuItem = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->exitToolStripMenuItem = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->labelTitle = (gcnew System::Windows::Forms::Label());
			this->richTextOut = (gcnew System::Windows::Forms::RichTextBox());
			this->buttonFind = (gcnew System::Windows::Forms::Button());
			this->buttonFindUp = (gcnew System::Windows::Forms::Button());
			this->textBoxFind = (gcnew System::Windows::Forms::TextBox());
			this->menuStripHelp->SuspendLayout();
			this->SuspendLayout();
			// 
			// menuStripHelp
			// 
			this->menuStripHelp->BackColor = System::Drawing::SystemColors::ControlLightLight;
			this->menuStripHelp->Items->AddRange(gcnew cli::array< System::Windows::Forms::ToolStripItem^  >(1) {this->fileToolStripMenuItem});
			this->menuStripHelp->Location = System::Drawing::Point(0, 0);
			this->menuStripHelp->Name = L"menuStripHelp";
			this->menuStripHelp->Size = System::Drawing::Size(682, 24);
			this->menuStripHelp->TabIndex = 0;
			this->menuStripHelp->Text = L"menuStripHelp";
			// 
			// fileToolStripMenuItem
			// 
			this->fileToolStripMenuItem->DropDownItems->AddRange(gcnew cli::array< System::Windows::Forms::ToolStripItem^  >(1) {this->exitToolStripMenuItem});
			this->fileToolStripMenuItem->Name = L"fileToolStripMenuItem";
			this->fileToolStripMenuItem->Size = System::Drawing::Size(35, 20);
			this->fileToolStripMenuItem->Text = L"&File";
			// 
			// exitToolStripMenuItem
			// 
			this->exitToolStripMenuItem->Name = L"exitToolStripMenuItem";
			this->exitToolStripMenuItem->Size = System::Drawing::Size(92, 22);
			this->exitToolStripMenuItem->Text = L"E&xit";
			this->exitToolStripMenuItem->Click += gcnew System::EventHandler(this, &HelpForm::exitToolStripMenuItem_Click);
			// 
			// labelTitle
			// 
			this->labelTitle->Font = (gcnew System::Drawing::Font(L"Tahoma", 12, System::Drawing::FontStyle::Bold));
			this->labelTitle->Location = System::Drawing::Point(24, 32);
			this->labelTitle->Name = L"labelTitle";
			this->labelTitle->Size = System::Drawing::Size(416, 23);
			this->labelTitle->TabIndex = 1;
			this->labelTitle->Text = L"<App.Title> Help Form";
			// 
			// richTextOut
			// 
			this->richTextOut->BackColor = System::Drawing::SystemColors::Window;
			this->richTextOut->Font = (gcnew System::Drawing::Font(L"Courier New", 9.5F, System::Drawing::FontStyle::Bold));
			this->richTextOut->Location = System::Drawing::Point(0, 59);
			this->richTextOut->Name = L"richTextOut";
			this->richTextOut->ReadOnly = true;
			this->richTextOut->Size = System::Drawing::Size(680, 428);
			this->richTextOut->TabIndex = 0;
			this->richTextOut->Text = L"";
			this->richTextOut->KeyDown += gcnew System::Windows::Forms::KeyEventHandler(this, &HelpForm::richTextOut_KeyDown);
			// 
			// buttonFind
			// 
			this->buttonFind->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 6.75F, System::Drawing::FontStyle::Bold, System::Drawing::GraphicsUnit::Point, 
				static_cast<System::Byte>(0)));
			this->buttonFind->Location = System::Drawing::Point(440, 32);
			this->buttonFind->Name = L"buttonFind";
			this->buttonFind->Size = System::Drawing::Size(56, 24);
			this->buttonFind->TabIndex = 4;
			this->buttonFind->Text = L"F3 Find:";
			this->buttonFind->UseVisualStyleBackColor = true;
			this->buttonFind->Click += gcnew System::EventHandler(this, &HelpForm::buttonFind_Click);
			// 
			// buttonFindUp
			// 
			this->buttonFindUp->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 6.75F, System::Drawing::FontStyle::Bold, System::Drawing::GraphicsUnit::Point, 
				static_cast<System::Byte>(0)));
			this->buttonFindUp->Location = System::Drawing::Point(608, 32);
			this->buttonFindUp->Name = L"buttonFindUp";
			this->buttonFindUp->Size = System::Drawing::Size(48, 24);
			this->buttonFindUp->TabIndex = 5;
			this->buttonFindUp->Text = L"F2 Up";
			this->buttonFindUp->UseVisualStyleBackColor = true;
			this->buttonFindUp->Click += gcnew System::EventHandler(this, &HelpForm::buttonFindUp_Click);
			// 
			// textBoxFind
			// 
			this->textBoxFind->Location = System::Drawing::Point(504, 32);
			this->textBoxFind->Name = L"textBoxFind";
			this->textBoxFind->Size = System::Drawing::Size(100, 20);
			this->textBoxFind->TabIndex = 2;
			// 
			// HelpForm
			// 
			this->AutoScaleMode = System::Windows::Forms::AutoScaleMode::Inherit;
			this->ClientSize = System::Drawing::Size(682, 456);
			this->Controls->Add(this->textBoxFind);
			this->Controls->Add(this->buttonFindUp);
			this->Controls->Add(this->buttonFind);
			this->Controls->Add(this->richTextOut);
			this->Controls->Add(this->labelTitle);
			this->Controls->Add(this->menuStripHelp);
			this->Icon = (cli::safe_cast<System::Drawing::Icon^  >(resources->GetObject(L"$this.Icon")));
			this->MainMenuStrip = this->menuStripHelp;
			this->Name = L"HelpForm";
			this->Text = L"<App.Title> - Help";
			this->Resize += gcnew System::EventHandler(this, &HelpForm::HelpForm_Resize);
			this->FormClosing += gcnew System::Windows::Forms::FormClosingEventHandler(this, &HelpForm::HelpForm_FormClosing);
			this->menuStripHelp->ResumeLayout(false);
			this->menuStripHelp->PerformLayout();
			this->ResumeLayout(false);
			this->PerformLayout();

		}
#pragma endregion

		public: void Help()	// -------- Begin Main program Help
		{
			if (Global::helpUp >= 3) { this->~HelpForm(); return; }	// allow at most 3 Help Forms up
			Global::helpUp++;
			this->Cursor = Cursors::Arrow; // ?
			this->Text = Global::title + " - Help";
			labelTitle->Text = Global::title + " Help";
			HelpFile = Global::pName + "Help.txt";
			ReadHelp();
			RunForm::FocusBothUs();
			helpTextOut->Select(0, 0);	// move cursor to top
			helpTextOut->Focus();		// and focus
			this->Width = RunForm::helpWidth;	// Resize the form
			this->Height = RunForm::helpHeight;
		}

		private: void ReadHelp()
		{
			StreamReader^ readHelpFile;
			String^ line;
			try
			{
				helpTextOut->Text = "";				// clear text output window
				PLn("");
				PLn("Reading Help File: " + HelpFile);
				String^ dir;
				bool opened = Global::OpenRead(readHelpFile, HelpFile, dir); // open the file
				if (!opened) // if not opened
				{
					PLn("File not found: " + HelpFile); // file not found
					return;
				}
				helpTextOut->Text = "";				// clear text output window again
				line = readHelpFile->ReadLine();	// read first line of file
				while (!readHelpFile->EndOfStream)	// loop until end of file
				{
					PLn("  " + line);					// output a line of Help
					line = readHelpFile->ReadLine();	// read in next line
				}
				PLn("  " + line);					// output a line of Help // ?/
			}
			catch (const char ex)
			{
				PLn("ReadHelp: " + ex.ToString());		// read error
				Global::ReportError("ReadHelp", ex.ToString());
			}
			finally
			{
				if (readHelpFile)
				{
					readHelpFile->Close();				// close the file
				}
			}
		} // ReadHelp

		private: void Prn(String^ st) // print string to textOut window
		{
			helpTextOut->AppendText(st);
		}

		private: void PLn(String^ st) // print string ... and new line to textOut
		{
			Prn(st + "\n");
		}

		private: System::Void exitToolStripMenuItem_Click(System::Object^  sender, System::EventArgs^  e)
		{
			Global::helpUp--;
			this->~HelpForm();
		}

		private: System::Void HelpForm_Resize(System::Object^  sender, System::EventArgs^  e)
		{
			int jTop = labelTitle->Top + labelTitle->Height + 5;
			this->richTextOut->SetBounds(1, jTop, this->ClientRectangle.Width - 2, this->ClientRectangle.Height - jTop - 1);
		}

		private: System::Void richTextOut_KeyDown(System::Object^  sender, System::Windows::Forms::KeyEventArgs^  e)
		{
			if (e->KeyCode == Keys::Escape) // ESC key pressed so Exit Help
			{
				Global::helpUp--;
				this->~HelpForm();
			}
			if (e->KeyCode == Keys::F2)	// F2 key pressed so do a find going up
			{
				buttonFindUp_Click(sender, e);
			}
			if (e->KeyCode == Keys::F3 || e->KeyCode == Keys::Return)	// F3 key or Return pressed so do a normal find
			{
				buttonFind_Click(sender, e);
			}
			if (e->KeyCode == Keys::F)	// F key pressed so copy selected text to textBoxFind
			{
				if (e->Control)
				{
					String^ st = helpTextOut->SelectedText;	// only copy up to first newline
					int i = st->IndexOf("\n");
					if (i >= 0) st = st->Substring(0, i);
					textBoxFind->Text = st;
					textBoxFind->Select(0, st->Length);		// move cursor found location
					textBoxFind->Focus();					// and focus
				}
			}
		} // richTextOut_KeyDown

		public: int FindMyText(String^ searchText, int searchStart, int searchEnd)
		{
			// Initialize the return value to false by default.
			int returnValue = -1;

			// Ensure that a search string and a valid starting point are specified.
			if (searchText->Length > 0 && searchStart >= 0)
			{
				// Ensure that a valid ending value is provided.
				if (searchEnd > searchStart || searchEnd == -1)
				{
					// Obtain the location of the search string in the richTextBox.
					int indexToText = richTextOut->Find(searchText, searchStart, searchEnd, RichTextBoxFinds::None);
					// Determine whether the text was found in richTextBox1.
					if (indexToText >= 0)
					{
						// Return the index to the specified search text.
						returnValue = indexToText;
					}
				}
			}
			return returnValue;
		} // FindMyText

		public: int FindMyTextUp(String^ searchText, int searchStart, int searchEnd)
		{
			// Initialize the return value to false by default.
			int returnValue = -1;

			// Ensure that a search string and a valid starting point are specified.
			if (searchText->Length > 0 && searchStart >= 0)
			{
				// Ensure that a valid ending value is provided.
				if (searchEnd > searchStart || searchEnd == -1)
				{
					// Obtain the location of the search string in the richTextBox.
					int indexToText = richTextOut->Find(searchText, searchStart, searchEnd, RichTextBoxFinds::Reverse);
					// Determine whether the text was found in richTextBox1.
					if (indexToText >= 0)
					{
						// Return the index to the specified search text.
						returnValue = indexToText;
					}
				}
			}
			return returnValue;
		} // FindMyTextUp

		private: void Play(LPCTSTR fileName) // play the sound in the file
		{
			PlaySound(fileName, NULL, SND_FILENAME|SND_ASYNC);
		}

		private: System::Void buttonFind_Click(System::Object^  sender, System::EventArgs^  e)
		{
			int found = -1;
			helpTextOut->Focus();				// focus on output text
			if (textBoxFind->Text != "")
				findSt = textBoxFind->Text;
			int length = findSt->Length;
			if (length == 0)
				return;
			int scope = helpTextOut->Text->Length;
			int start = helpTextOut->SelectionStart;
			int begin = Math::Min(start + 1, scope);
			if (begin != scope)
				found = FindMyText(findSt, begin, scope);
			if (found < 0)
			{
				int end = Math::Min(start + length, scope);
				found = FindMyText(findSt, 0, end);
				if (found >= 0)
				{
					Play(L"Wrap.wav");
				}
				else
				{
					Play(L"NotFound.wav");
				}
			}
			else
			{
				TryBeep(277, 50);					// beep Frequency 277Hz, Length 50ms
			}										// 277 is middle C#
			if (found >= 0)
			{
				helpTextOut->Select(found, length);	// move cursor found location
				helpTextOut->Focus();				// and focus
			}
		} // buttonFind_Click

		private: System::Void buttonFindUp_Click(System::Object^  sender, System::EventArgs^  e)
		{
			int found = -1;
			helpTextOut->Focus();				// focus on output text
			if (textBoxFind->Text != "")
				findSt = textBoxFind->Text;
			int length = findSt->Length;
			if (length == 0)
				return;
			int scope = helpTextOut->Text->Length;
			int start = helpTextOut->SelectionStart + length;
			int end = Math::Max(start - 1, 0);
			if (end != 0)
				found = FindMyTextUp(findSt, 0, end);
			if (found < 0)
			{
				int begin = Math::Max(start - length, 0);
				found = FindMyTextUp(findSt, begin, scope);
				if (found >= 0)
				{
					Play(L"Wrap.wav");
				}
				else
				{
					Play(L"NotFound.wav");
				}
			}
			else
			{
				TryBeep(277 * 2, 50);				// beep Frequency 554Hz, Length 50ms
			}										// 554 is one octave above middle C#
			if (found >= 0)
			{
				helpTextOut->Select(found, length);	// move cursor found location
				helpTextOut->Focus();				// and focus
			}
		} // buttonFindUp_Click

		private: void TryBeep(int freq, int dur)
		{
			try
			{
				Console::Beep(freq, dur);			// beep freq, duration
			}
			catch (const char)
			{
				// DllImport("kernel32.dll") file not found or no Beep entry point in the file
				// so no beep
			}
		}

		private: System::Void HelpForm_FormClosing(System::Object^  sender, System::Windows::Forms::FormClosingEventArgs^  e)
		{
			Global::helpUp--;
		}

		private: static RichTextBox^ helpTextOut;
		private: static String^ HelpFile;			// file name of Help file
		private: static String^ findSt;				// string to find
	};
}
