#pragma once

#include "RunForm.h"
#include "HelpForm.h"

using namespace System;

namespace MyNamespace
{
	/// <summary>
	/// Summary for StartupForm
	///
	/// WARNING: If you change the name of this class, you will need to change the
	///          'Resource File Name' property for the managed resource compiler tool
	///          associated with all .resx files this class depends on.  Otherwise,
	///          the designers will not be able to interact properly with localized
	///          resources associated with this form.
	/// </summary>
	public ref class StartupForm : public System::Windows::Forms::Form
	{
		public: StartupForm(void)
		{
			InitializeComponent();
			//
			//TODO: Add the constructor code here
			//
			RunForm::startupQuitFlag = false;
			Global::logFileB = "Algo358F.Log";
			startupTicks = 1;
			defaultTestCase = 1;
			SetDefault();
			this->Text = Global::title + " - Startup";
			Pr("");
			Pr("   " + Global::name1);
			Pr("   " + Global::name2);
			Pr("   " + Global::version);
			Pr("   " + Global::author);
			Pr("   " + Global::address);
			Pr("");
			Pr("Algo358F is a program with the following features:");
			Pr("");
			Pr("     Tests the CSVD routine, ACM Algorithm 358 in C++.");
			Pr("");
			Pr("     Computes the Singular Value Decomposition of an m by n");
			Pr("     complex matrix a, which gives u as an m by m matrix, s an");
			Pr("     n by n diagonal matrix and u an n by n matrix, such that");
			Pr("     a = u * s * Conj(Tran(v)).");
			Pr("");
			Pr("     See: http://www.library.cornell.edu/nr/bookcpdf/c2-6.pdf");
			Pr("     Numerical Recipes Books On-Line.");
			Pr("");
			Pr("     See:");
			Pr("http://www.scs.fsu.edu/~burkardt/f77_src/toms358/toms358.f");
			Pr("http://www.scs.fsu.edu/~burkardt/f77_src/toms358/toms358_prb.f");
			Pr("     for the FORTRAN code.");
			Pr("     ");
			if (Global::command != "")
			{
				textBoxTestCase->Text = Global::command;
				textBoxTestCase_TextChanged();
				if (bTc)
					buttonRun_Click();
			}
			else
				textBoxTestCase->Text = "1";
		}

		protected:
		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		~StartupForm()
		{
			if (components)
			{
				delete components;
			}
		}

		private: System::Windows::Forms::RichTextBox^  richTextIntro;
		private: System::Windows::Forms::Label^  labelTestCase;
		private: System::Windows::Forms::TextBox^  textBoxTestCase;
		private: System::Windows::Forms::Button^  buttonDefault;
		private: System::Windows::Forms::Button^  buttonRun;
		private: System::Windows::Forms::Button^  buttonExit;
		private: System::Windows::Forms::Timer^  timerStartup;
		private: System::ComponentModel::IContainer^  components;

		private:
		/// <summary>
		/// Required designer variable.
		/// </summary>


#pragma region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		void InitializeComponent(void)
		{
			this->components = (gcnew System::ComponentModel::Container());
			System::ComponentModel::ComponentResourceManager^  resources = (gcnew System::ComponentModel::ComponentResourceManager(StartupForm::typeid));
			this->richTextIntro = (gcnew System::Windows::Forms::RichTextBox());
			this->labelTestCase = (gcnew System::Windows::Forms::Label());
			this->textBoxTestCase = (gcnew System::Windows::Forms::TextBox());
			this->buttonDefault = (gcnew System::Windows::Forms::Button());
			this->buttonRun = (gcnew System::Windows::Forms::Button());
			this->buttonExit = (gcnew System::Windows::Forms::Button());
			this->timerStartup = (gcnew System::Windows::Forms::Timer(this->components));
			this->SuspendLayout();
			// 
			// richTextIntro
			// 
			this->richTextIntro->BackColor = System::Drawing::Color::FromArgb(static_cast<System::Int32>(static_cast<System::Byte>(208)), static_cast<System::Int32>(static_cast<System::Byte>(244)), 
				static_cast<System::Int32>(static_cast<System::Byte>(255)));
			this->richTextIntro->Font = (gcnew System::Drawing::Font(L"Tahoma", 9.75F, System::Drawing::FontStyle::Bold, System::Drawing::GraphicsUnit::Point, 
				static_cast<System::Byte>(0)));
			this->richTextIntro->ForeColor = System::Drawing::Color::Blue;
			this->richTextIntro->Location = System::Drawing::Point(0, 0);
			this->richTextIntro->Name = L"richTextIntro";
			this->richTextIntro->ReadOnly = true;
			this->richTextIntro->ScrollBars = System::Windows::Forms::RichTextBoxScrollBars::None;
			this->richTextIntro->Size = System::Drawing::Size(464, 472);
			this->richTextIntro->TabIndex = 7;
			this->richTextIntro->Text = L"";
			this->richTextIntro->TextChanged += gcnew System::EventHandler(this, &StartupForm::richTextIntro_TextChanged);
			// 
			// labelTestCase
			// 
			this->labelTestCase->Location = System::Drawing::Point(488, 189);
			this->labelTestCase->Name = L"labelTestCase";
			this->labelTestCase->Size = System::Drawing::Size(100, 16);
			this->labelTestCase->TabIndex = 3;
			this->labelTestCase->Text = L"Test Case Number";
			// 
			// textBoxTestCase
			// 
			this->textBoxTestCase->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 8.25F, System::Drawing::FontStyle::Bold, System::Drawing::GraphicsUnit::Point, 
				static_cast<System::Byte>(0)));
			this->textBoxTestCase->Location = System::Drawing::Point(496, 208);
			this->textBoxTestCase->Name = L"textBoxTestCase";
			this->textBoxTestCase->Size = System::Drawing::Size(72, 20);
			this->textBoxTestCase->TabIndex = 5;
			this->textBoxTestCase->Text = L"1";
			this->textBoxTestCase->TextChanged += gcnew System::EventHandler(this, &StartupForm::textBoxTestCase_TextChanged);
			// 
			// buttonDefault
			// 
			this->buttonDefault->Location = System::Drawing::Point(480, 280);
			this->buttonDefault->Name = L"buttonDefault";
			this->buttonDefault->Size = System::Drawing::Size(104, 24);
			this->buttonDefault->TabIndex = 6;
			this->buttonDefault->Text = L"Default Settings";
			this->buttonDefault->UseVisualStyleBackColor = true;
			this->buttonDefault->Click += gcnew System::EventHandler(this, &StartupForm::buttonDefault_Click);
			// 
			// buttonRun
			// 
			this->buttonRun->Cursor = System::Windows::Forms::Cursors::Arrow;
			this->buttonRun->Location = System::Drawing::Point(480, 432);
			this->buttonRun->Name = L"buttonRun";
			this->buttonRun->Size = System::Drawing::Size(40, 24);
			this->buttonRun->TabIndex = 0;
			this->buttonRun->Text = L"Run";
			this->buttonRun->UseVisualStyleBackColor = true;
			this->buttonRun->Click += gcnew System::EventHandler(this, &StartupForm::buttonRun_Click);
			// 
			// buttonExit
			// 
			this->buttonExit->Cursor = System::Windows::Forms::Cursors::Arrow;
			this->buttonExit->Location = System::Drawing::Point(536, 432);
			this->buttonExit->Name = L"buttonExit";
			this->buttonExit->Size = System::Drawing::Size(40, 23);
			this->buttonExit->TabIndex = 1;
			this->buttonExit->Text = L"Exit";
			this->buttonExit->UseVisualStyleBackColor = true;
			this->buttonExit->Click += gcnew System::EventHandler(this, &StartupForm::buttonExit_Click);
			// 
			// timerStartup
			// 
			this->timerStartup->Enabled = true;
			this->timerStartup->Tick += gcnew System::EventHandler(this, &StartupForm::timerStartup_Tick);
			// 
			// StartupForm
			// 
			this->AutoScaleMode = System::Windows::Forms::AutoScaleMode::Inherit;
			this->ClientSize = System::Drawing::Size(600, 470);
			this->Controls->Add(this->buttonExit);
			this->Controls->Add(this->buttonRun);
			this->Controls->Add(this->buttonDefault);
			this->Controls->Add(this->textBoxTestCase);
			this->Controls->Add(this->labelTestCase);
			this->Controls->Add(this->richTextIntro);
			this->Icon = (cli::safe_cast<System::Drawing::Icon^  >(resources->GetObject(L"$this.Icon")));
			this->Name = L"StartupForm";
			this->StartPosition = System::Windows::Forms::FormStartPosition::CenterScreen;
			this->Text = L"<App.Title> - Startup";
			this->ResumeLayout(false);
			this->PerformLayout();

		}
#pragma endregion

		private: void Pr(String^ st)
		{
			richTextIntro->Text += "   " + st + "\n";
		}

		private: System::Void richTextIntro_TextChanged(System::Object^  sender, System::EventArgs^  e)
		{
		}

		private: System::Void buttonExit_Click(System::Object^  sender, System::EventArgs^  e)
		{
			this->~StartupForm();
		}

		private: System::Void textBoxTestCase_TextChanged(System::Object^  sender, System::EventArgs^  e)
		// test case [1, 2]
		{
			textBoxTestCase_TextChanged();
		}

		private: System::Void textBoxTestCase_TextChanged()
		// test case [1, 2]
		{
			String^ sTc = textBoxTestCase->Text->TrimStart(' ');	// remove leading spaces
			textBoxTestCase->Text = sTc;
			if (Global::IsInt32(sTc))
			{
				int iTc = Convert::ToInt32(sTc);
				bTc = (1 <= iTc) && (iTc <= 2);
			}
			else
				bTc = false;
			int n = sTc->Length;
			if (n > 0 && sTc[n-1] == ' ') // remove space at end
			{
					sTc = sTc->TrimEnd(' ');
					textBoxTestCase->Text = sTc;
					textBoxTestCase->SelectionStart = sTc->Length; // stay at end
			}
			SetFonts();
		}

		private: System::Void buttonDefault_Click(System::Object^  sender, System::EventArgs^  e)
		{
			SetDefault();
		} 

		private: void SetDefault()
		{
			textBoxTestCase->Text = "1";
			buttonRun->Enabled = bTc = true;
		} 

		private: System::Void buttonRun_Click(System::Object^  sender, System::EventArgs^  e)
		// start running the program
		{
			buttonRun_Click();
		}

		private: void buttonRun_Click() // start running the program
		{
			int iTc = Convert::ToInt32(textBoxTestCase->Text);
			objRunForm = gcnew RunForm();
			objRunForm->Show();
			objRunForm->Run(iTc);//, StartupForm()); // call sub Run in the form frmRun
			this->Hide();
		}

		private: void SetFonts()
		{
			if (bTc)
				textBoxTestCase->Font = gcnew Drawing::Font("Microsoft Sans Serif", 8.25F, Drawing::FontStyle::Bold);
			else
				textBoxTestCase->Font = gcnew Drawing::Font("Microsoft Sans Serif", 8.25F, Drawing::FontStyle::Regular);
			buttonRun->Enabled = bTc;
		}

		private: System::Void timerStartup_Tick(System::Object^  sender, System::EventArgs^  e)
		{
			if (RunForm::startupQuitFlag)
				this->~StartupForm();
			else if (Global::runFormUp)
			{
				this->Hide();	// this is only needed when there command line arguments are input
				if (Global::newHelp)
				{
					Global::newHelp = false;
					HelpForm^ objHelpForm = gcnew HelpForm();
					objHelpForm->Show();
					objHelpForm->Help();
				}
				if (Global::newSetLogCaption)
				{
					Global::newSetLogCaption = false;
					objRunForm->SetLogCaption();
				}
			}
			else
			{
				this->Show();
			}
		}

		private: static bool bTc;				// Test case good flag
		private: static int defaultTestCase;	// Test case default
		private: static int startupTicks = 0;	// startupTicks helps implement the requirement that the
												// StartupForm is bypassed if command line arguments are present
		public: static RunForm^ objRunForm;		// the RunForm object for function calls
	};
}
